Index: trunk/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 503)
@@ -4,7 +4,15 @@
    !! Ocean diagnostics:  mixed layer T-S trends 
    !!=====================================================================
+   !! History :       !  95-04  (J. Vialard)    Original code
+   !!                 !  97-02  (E. Guilyardi)  Adaptation global + base cmo
+   !!                 !  99-09  (E. Guilyardi)  Re-writing + netCDF output
+   !!            8.5  !  02-06  (G. Madec)      F90: Free form and module
+   !!            9.0  !  04-08  (C. Talandier)  New trends organization
+   !!                 !  05-05  (C. Deltel)     Diagnose trends of time averaged ML T & S
+   !!----------------------------------------------------------------------
 #if   defined key_trdmld   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_trdmld'                          mixed layer trend diagnostics
+   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trd_mld          : T and S cumulated trends averaged over the mixed layer
@@ -12,5 +20,4 @@
    !!   trd_mld_init     : initialization step
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
@@ -28,46 +35,19 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE diadimg         ! dimg direct access file format output
+   USE trdmld_rst , ONLY : trd_mld_rst_read  ! restart for diagnosing the ML trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC trd_mld        ! routine called by step.F90
-   PUBLIC trd_mld_init   ! routine called by opa.F90
-   PUBLIC trd_mld_zint   ! routine called by tracers routines
-
-   !! * Shared module variables
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .TRUE.    !: momentum trend flag
-
-   !! * Module variables
-   INTEGER ::   &
-      nh_t, nmoymltrd,             &  ! ???
-      nidtrd,                      &
-      ndextrd1(jpi*jpj),           &
-      ndimtrd1
-   INTEGER, SAVE ::   &
-      ionce, icount,               &
-      idebug                          ! (0/1) set it to 1 in case of problem to have more print
-
-   INTEGER, DIMENSION(jpi,jpj) ::   &
-      nmld,                         & ! mixed layer depth
-      nbol                
-
-   REAL(wp), DIMENSION(jpi,jpj) ::   &
-      rmld   ,          &  ! mld depth (m) corresponding to nmld
-      tml    , sml  ,   &  ! average T and S over mixed layer
-      tmlb   , smlb ,   &  ! before tml and sml (kt-1)
-      tmlbb  , smlbb,   &  ! tml and sml at begining of the nwrite-1 
-      !                    ! timestep averaging period
-      tmlbn  , smlbn,   &  ! after tml and sml at time step after the
-      !                    ! begining of the NWRITE-1 timesteps
-      tmltrdm, smltrdm     !
-
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-      tmltrd ,          &  ! total cumulative trends of temperature and 
-      smltrd ,          &  ! salinity over nwrite-1 time steps
-      wkx
-
-   CHARACTER(LEN=80) :: clname
+   PUBLIC   trd_mld        ! routine called by step.F90
+   PUBLIC   trd_mld_init   ! routine called by opa.F90
+   PUBLIC   trd_mld_zint   ! routine called by tracers routines
+
+   CHARACTER (LEN=40) ::  clhstnam         ! name of the trends NetCDF file
+   INTEGER ::   nh_t, nmoymltrd
+   INTEGER ::   nidtrd, ndextrd1(jpi*jpj)
+   INTEGER ::   ndimtrd1                        
+   INTEGER, SAVE ::  ionce, icount                   
 
    !! * Substitutions
@@ -83,114 +63,55 @@
 CONTAINS
 
-SUBROUTINE trd_mld_zint( pttrdmld, pstrdmld, ktrd, ctype )
+   SUBROUTINE trd_mld_zint( pttrdmld, pstrdmld, ktrd, ctype )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mld_zint  ***
       !! 
-      !! ** Purpose :   computation of vertically integrated T and S budgets
-      !!                from ocean surface down to control surface 
+      !! ** Purpose :   Compute the vertical average of the 3D fields given as arguments 
+      !!                to the subroutine. This vertical average is performed from ocean
+      !!                surface down to a chosen control surface.
       !!
       !! ** Method/usage :
-      !!      integration done over nwrite-1 time steps 
-      !!      Control surface can be either a mixed layer depth (time varying)
+      !!      The control surface can be either a mixed layer depth (time varying)
       !!      or a fixed surface (jk level or bowl). 
-      !!      Choose control surface with nctls in namelist NAMDIA.
-      !!      nctls = 0  : use mixed layer with density criterion 
-      !!      nctls = 1  : read index from file 'ctlsurf_idx'
-      !!      nctls > 1  : use fixed level surface jk = nctls
+      !!      Choose control surface with nctls in namelist NAMTRD :
+      !!        nctls = 0  : use mixed layer with density criterion 
+      !!        nctls = 1  : read index from file 'ctlsurf_idx'
+      !!        nctls > 1  : use fixed level surface jk = nctls
       !!      Note: in the remainder of the routine, the volume between the 
       !!            surface and the control surface is called "mixed-layer"
-      !!      Method check : if the control surface is fixed, the residual dh/dt
-      !!                     entrainment should be zero
-      !!
-      !! ** Action :
-      !!            /commld/   : rmld         mld depth corresponding to nmld
-      !!                         tml          average T over mixed layer
-      !!                         tmlb         tml at kt-1
-      !!                         tmlbb        tml at begining of the NWRITE-1 
-      !!                                      time steps averaging period
-      !!                         tmlbn        tml at time step after the 
-      !!                                      begining of the NWRITE-1 time
-      !!                                      steps averaging period
-      !!
-      !!                  mixed layer trends :
-      !!
-      !!                  tmltrd (,,1) = zonal advection
-      !!                  tmltrd (,,2) = meridional advection
-      !!                  tmltrd (,,3) = vertical advection
-      !!                  tmltrd (,,4) = lateral diffusion (horiz. component+Beckman)
-      !!                  tmltrd (,,5) = forcing
-      !!                  tmltrd (,,6) = entrainment due to vertical diffusion (TKE)
-      !!          if iso  tmltrd (,,7) = lateral diffusion (vertical component)
-      !!                  tmltrd (,,8) = eddy induced zonal advection
-      !!                  tmltrd (,,9) = eddy induced meridional advection
-      !!                  tmltrd (,,10) = eddy induced vertical advection
-      !!
-      !!                  tmltrdm(,) : total cumulative trends over nwrite-1 time steps
-      !!                  ztmltot(,) : dT/dt over the NWRITE-1 time steps 
-      !!                               averaging period (including Asselin 
-      !!                               terms)
-      !!                  ztmlres(,) : residual = dh/dt entrainment
-      !!
-      !!      trends output in netCDF format using ioipsl
-      !!
-      !! History :
-      !!        !  95-04  (J. Vialard)  Original code
-      !!        !  97-02  (E. Guilyardi)  Adaptation global + base cmo
-      !!        !  99-09  (E. Guilyardi)  Re-writing + netCDF output
-      !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
       !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-
-      CHARACTER(len=2), INTENT( in ) ::   &
-         ctype                                ! surface/bottom (2D arrays) or
-                                              ! interior (3D arrays) physics
-
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   &
-         pttrdmld,                         &  ! Temperature trend 
-         pstrdmld                             ! Salinity    trend
-
-      !! * Local declarations
+      INTEGER, INTENT( in ) ::   ktrd                             ! ocean trend index
+      CHARACTER(len=2), INTENT( in ) :: ctype                     ! surface/bottom (2D arrays) or
+      !                                                           ! interior (3D arrays) physics
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::  pttrdmld ! temperature trend 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::  pstrdmld ! salinity trend 
       INTEGER ::   ji, jj, jk, isum
-# if defined key_trabbl_dif
-      INTEGER ::   ikb
-# endif
-
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zvlmsk
+      REAL(wp), DIMENSION(jpi,jpj) ::  zvlmsk
       !!----------------------------------------------------------------------
 
+      ! I. Definition of control surface and associated fields
+      ! ------------------------------------------------------
+      !            ==> only once per time step <== 
+
       IF( icount == 1 ) THEN        
-
-         zvlmsk(:,:)   = 0.e0
-         tmltrd(:,:,:) = 0.e0
-         smltrd(:,:,:) = 0.e0
-         
-         ! This computation should be done only once per time step
-
-         !  ========================================================
-         !   I. definition of control surface and associated fields
-         !  ========================================================
-
-         !    I.1 set nmld(ji,jj) = index of first T point below control surface
-         !    -------------------                       or outside mixed-layer
-
-         IF( nctls == 0 ) THEN
-            ! control surface = mixed-layer with density criterion 
-            ! (array nmln computed in zdfmxl.F90)
-            nmld(:,:) = nmln(:,:)
-         ELSE IF( nctls == 1 ) THEN
-            ! control surface = read index from file 
+         !
+         tmltrd(:,:,:) = 0.e0    ;    smltrd(:,:,:) = 0.e0    ! <<< reset trend arrays to zero
+         
+         ! ... Set nmld(ji,jj) = index of first T point below control surf. or outside mixed-layer
+         IF( nctls == 0 ) THEN       ! * control surface = mixed-layer with density criterion 
+            nmld(:,:) = nmln(:,:)    ! array nmln computed in zdfmxl.F90
+         ELSE IF( nctls == 1 ) THEN  ! * control surface = read index from file 
             nmld(:,:) = nbol(:,:)
-         ELSE IF( nctls >= 2 ) THEN
-            ! control surface = model level
+         ELSE IF( nctls >= 2 ) THEN  ! * control surface = model level
             nctls = MIN( nctls, jpktrd - 1 )
             nmld(:,:) = nctls + 1
          ENDIF
 
-         IF( ionce == 1 ) THEN  ! compute ndextrd1 and ndimtrd1 only once
-            ! Check of validity : nmld(ji,jj) =< jpktrd
-            isum = 0
+         ! ... Compute ndextrd1 and ndimtrd1 only once
+         IF( ionce == 1 ) THEN
+            !
+            ! Check of validity : nmld(ji,jj) <= jpktrd
+            isum        = 0
+            zvlmsk(:,:) = 0.e0
 
             IF( jpktrd < jpk ) THEN 
@@ -215,118 +136,47 @@
             ENDIF                                
 
-            ! no more pass here
-            ionce = 0
-
-         ENDIF
-         
-         IF( idebug /= 0 ) THEN
-            ! CALL prihre (zvlmsk,jpi,jpj,1,jpi,2,1,jpj,2,3,numout)
-            WRITE(numout,*) ' debuging trd_mld_zint: I.1 done '  
-            CALL FLUSH(numout)
-         ENDIF
-
-
-         ! I.2 probability density function of presence in mixed-layer
-         ! --------------------------------
-         ! (i.e. weight of each grid point in vertical integration : wkx(ji,jj,jk)
-
-
-         ! initialize wkx with vertical scale factor in mixed-layer
-
+            ionce = 0                ! no more pass here
+            !
+         END IF
+         
+         ! ... Weights for vertical averaging
          wkx(:,:,:) = 0.e0
-         DO jk = 1, jpktrd
+         DO jk = 1, jpktrd             ! initialize wkx with vertical scale factor in mixed-layer
             DO jj = 1,jpj
                DO ji = 1,jpi
-                  IF( jk - nmld(ji,jj) < 0. )   wkx(ji,jj,jk) = fse3t(ji,jj,jk) * tmask(ji,jj,jk)
+                  IF( jk - nmld(ji,jj) < 0.e0 )   wkx(ji,jj,jk) = fse3t(ji,jj,jk) * tmask(ji,jj,jk)
                END DO
             END DO
          END DO
          
-         ! compute mixed-layer depth : rmld
-         
-         rmld(:,:) = 0.
+         rmld(:,:) = 0.e0                ! compute mixed-layer depth : rmld
          DO jk = 1, jpktrd
             rmld(:,:) = rmld(:,:) + wkx(:,:,jk)
          END DO
          
-         ! compute PDF
-
+         DO jk = 1, jpktrd             ! compute integration weights
+            wkx(:,:,jk) = wkx(:,:,jk) / MAX( 1., rmld(:,:) )
+         END DO
+
+         icount = 0                    ! <<< flag = off : control surface & integr. weights
+         !                             !     computed only once per time step
+      END IF
+
+      ! II. Vertical integration of trends in the mixed-layer
+      ! -----------------------------------------------------
+
+      SELECT CASE (ctype)
+      CASE ( '3D' )   ! mean T/S trends in the mixed-layer
          DO jk = 1, jpktrd
-            wkx(:,:,jk) = wkx(:,:,jk) / MAX( 1., rmld(:,:) )
-         END DO
-
-         IF( idebug /= 0 ) THEN
-            WRITE(numout,*) ' debuging trd_mld_zint: I.2 done '  
-            CALL FLUSH(numout)
-         ENDIF
-
-         ! Set counter icount to 0 to avoid this part at each time step
-         icount = 0
-
-      ENDIF
-
-
-      !  ====================================================
-      !   II. vertical integration of trends in mixed-layer
-      !  ====================================================
-
-      ! II.1 vertical integration of 3D and 2D trends
-      ! ---------------------------------------------
-
-      SELECT CASE (ctype)
-
-      CASE ('3D')       ! 3D treatment
-
-         ! trends terms in the mixed-layer
-         DO jk = 1, jpktrd
-            ! Temperature
-            tmltrd(:,:,ktrd) = tmltrd(:,:,ktrd) + pttrdmld(:,:,jk) * wkx(:,:,jk)   
-
-            ! Salinity
-            smltrd(:,:,ktrd) = smltrd(:,:,ktrd) + pstrdmld(:,:,jk) * wkx(:,:,jk)   
-         ENDDO
-
-      CASE ('2D')       ! 2D treatment
-
-         SELECT CASE (ktrd) 
-
-         CASE (jpmldldf)
-
-# if defined key_trabbl_dif
-               ! trends terms from Beckman over-flow parameterization
-               DO jj = 1,jpj
-                  DO ji = 1,jpi
-                     ikb = MAX( mbathy(ji,jj)-1, 1 )
-                     ! beckmann component -> horiz. part of lateral diffusion
-                     tmltrd(ji,jj,ktrd) = tmltrd(ji,jj,ktrd) + pttrdmld(ji,jj,1) * wkx(ji,jj,ikb)
-                     smltrd(ji,jj,ktrd) = smltrd(ji,jj,ktrd) + pstrdmld(ji,jj,1) * wkx(ji,jj,ikb)
-                  END DO
-               END DO
-# endif
-
-         CASE DEFAULT
-
-            ! trends terms at upper boundary of mixed-layer
-
-            ! forcing term (non penetrative)
-            ! Temperature
-            tmltrd(:,:,ktrd) = tmltrd(:,:,ktrd) + pttrdmld(:,:,1) * wkx(:,:,1)   
-
-            ! forcing term
-            ! Salinity
-            smltrd(:,:,ktrd) = smltrd(:,:,ktrd) + pstrdmld(:,:,1) * wkx(:,:,1)   
-
-         END SELECT
-
+            tmltrd(:,:,ktrd) = tmltrd(:,:,ktrd) + pttrdmld(:,:,jk) * wkx(:,:,jk)   ! temperature
+            smltrd(:,:,ktrd) = smltrd(:,:,ktrd) + pstrdmld(:,:,jk) * wkx(:,:,jk)   ! salinity
+         END DO
+      CASE ( '2D' )   ! forcing at upper boundary of the mixed-layer
+         tmltrd(:,:,ktrd) = tmltrd(:,:,ktrd) + pttrdmld(:,:,1) * wkx(:,:,1)        ! non penetrative
+         smltrd(:,:,ktrd) = smltrd(:,:,ktrd) + pstrdmld(:,:,1) * wkx(:,:,1)            
       END SELECT
-
-      IF( idebug /= 0 ) THEN
-         IF(lwp) WRITE(numout,*) ' debuging trd_mld_zint: II.1 done'  
-         CALL FLUSH(numout)
-      ENDIF
-
+      !
    END SUBROUTINE trd_mld_zint
-
-
+    
 
    SUBROUTINE trd_mld( kt )
@@ -334,25 +184,61 @@
       !!                  ***  ROUTINE trd_mld  ***
       !! 
-      !! ** Purpose :  computation of cumulated trends over analysis period
-      !!               and make outputs (NetCDF or DIMG format)
+      !! ** Purpose :  Compute and cumulate the mixed layer trends over an analysis
+      !!               period, and write NetCDF (or dimg) outputs.
       !!
       !! ** Method/usage :
+      !!          The stored trends can be chosen twofold (according to the ln_trdmld_instant 
+      !!          logical namelist variable) :
+      !!          1) to explain the difference between initial and final 
+      !!             mixed-layer T & S (where initial and final relate to the
+      !!             current analysis window, defined by ntrd in the namelist)
+      !!          2) to explain the difference between the current and previous 
+      !!             TIME-AVERAGED mixed-layer T & S (where time-averaging is
+      !!             performed over each analysis window).
       !!
-      !! History :
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
+      !! ** Consistency check : 
+      !!        If the control surface is fixed ( nctls > 1 ), the residual term (dh/dt
+      !!        entrainment) should be zero, at machine accuracy. Note that in the case
+      !!        of time-averaged mixed-layer fields, this residual WILL NOT BE ZERO
+      !!        over the first two analysis windows (except if restart).
+      !!        N.B. For ORCA2_LIM, use e.g. ntrd=5, ucf=1., nctls=8
+      !!             for checking residuals.
+      !!             On a NEC-SX5 computer, this typically leads to:
+      !!                   O(1.e-20) temp. residuals (tml_res) when ln_trdmld_instant=.false.
+      !!                   O(1.e-21) temp. residuals (tml_res) when ln_trdmld_instant=.true.
+      !!
+      !! ** Action :
+      !!       At each time step, mixed-layer averaged trends are stored in the 
+      !!       tmltrd(:,:,jpmld_xxx) array (see trdmld_oce.F90 for definitions of jpmld_xxx).
+      !!       This array is known when trd_mld is called, at the end of the stp subroutine, 
+      !!       except for the purely vertical K_z diffusion term, which is embedded in the
+      !!       lateral diffusion trend.
+      !!
+      !!       In I), this K_z term is diagnosed and stored, thus its contribution is removed
+      !!       from the lateral diffusion trend.
+      !!       In II), the instantaneous mixed-layer T & S are computed, and misc. cumulative
+      !!       arrays are updated.
+      !!       In III), called only once per analysis window, we compute the total trends,
+      !!       along with the residuals and the Asselin correction terms.
+      !!       In IV), the appropriate trends are written in the trends NetCDF file.
+      !!
+      !! References :
+      !!       - Vialard & al.
+      !!       - See NEMO documentation (in preparation)
       !!----------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
-
-      !! * Local declarations
+      !!
       INTEGER :: ji, jj, jk, jl, ik, it
-
-      REAL(wp) :: zmean, zavt
-
-      REAL(wp) ,DIMENSION(jpi,jpj) ::   &
-         ztmltot, ztmlres,              &
-         zsmltot, zsmlres,              & 
-         z2d
-
+      LOGICAL :: lldebug = .TRUE.
+      REAL(wp) :: zavt, zfn, zfn2
+      REAL(wp) ,DIMENSION(jpi,jpj) ::     &
+           ztmltot,  zsmltot,             & ! dT/dt over the anlysis window (including Asselin)
+           ztmlres,  zsmlres,             & ! residual = dh/dt entrainment term
+           ztmlatf,  zsmlatf,             & ! needed for storage only
+           ztmltot2, ztmlres2, ztmltrdm2, & ! \  working arrays to diagnose the trends
+           zsmltot2, zsmlres2, zsmltrdm2, & !  > associated with the time meaned ML T & S
+           ztmlatf2, zsmlatf2               ! /
+      REAL(wp), DIMENSION(jpi,jpj,jpltrd) ::  &
+           ztmltrd2, zsmltrd2               ! only needed for mean diagnostics
 #if defined key_dimgout
       INTEGER ::  iyear,imon,iday
@@ -361,65 +247,56 @@
       !!----------------------------------------------------------------------
 
-      ! I. trends terms at lower boundary of mixed-layer
-      ! ------------------------------------------------
-
+      ! ======================================================================
+      ! I. Diagnose the purely vertical (K_z) diffusion trend
+      ! ======================================================================
+
+      ! ... These terms can be estimated by flux computation at the lower boundary of the ML 
+      !     (we compute (-1/h) * K_z * d_z( T ) and (-1/h) * K_z * d_z( S ))
       DO jj = 1,jpj
          DO ji = 1,jpi
-            
             ik = nmld(ji,jj)
-            
-            ! Temperature
-            ! entrainment due to vertical diffusion
-            !       - due to vertical mixing scheme (TKE)
             zavt = avt(ji,jj,ik)
-            tmltrd(ji,jj,jpmldevd) = - 1. * zavt / fse3w(ji,jj,ik) * tmask(ji,jj,ik)   &
-               &                   * ( tn(ji,jj,ik-1) - tn(ji,jj,ik) )   &
-               &                   / MAX( 1., rmld(ji,jj) ) * tmask(ji,jj,1)
-            ! Salinity
-            ! entrainment due to vertical diffusion
-            !       - due to vertical mixing scheme (TKE)
+            tmltrd(ji,jj,jpmld_zdf) = - zavt / fse3w(ji,jj,ik) * tmask(ji,jj,ik)  &
+               &                      * ( tn(ji,jj,ik-1) - tn(ji,jj,ik) )         &
+               &                      / MAX( 1., rmld(ji,jj) ) * tmask(ji,jj,1)
             zavt = fsavs(ji,jj,ik)
-            smltrd(ji,jj,jpmldevd) = -1. * zavt / fse3w(ji,jj,ik) * tmask(ji,jj,ik)   &
-               &                  * ( sn(ji,jj,ik-1) - sn(ji,jj,ik) )   &
-               &                  / MAX( 1., rmld(ji,jj) ) * tmask(ji,jj,1)
+            smltrd(ji,jj,jpmld_zdf) = - zavt / fse3w(ji,jj,ik) * tmask(ji,jj,ik)  &
+               &                      * ( sn(ji,jj,ik-1) - sn(ji,jj,ik) )         &
+               &                      / MAX( 1., rmld(ji,jj) ) * tmask(ji,jj,1)
          END DO
       END DO
 
+      ! ... Remove this K_z trend from the iso-neutral diffusion term (if any)
       IF( ln_traldf_iso ) THEN
-         ! We substract to the TOTAL vertical diffusion tmltrd(:,:,jpmldzdf) 
-         ! computed in subroutines trazdf_iso.F90 or trazdf_imp.F90
-         ! the vertical part du to the Kz in order to keep only the vertical
-         ! isopycnal diffusion (i.e the isopycnal diffusion componant on the vertical):
-         tmltrd(:,:,jpmldzdf) = tmltrd(:,:,jpmldzdf) - tmltrd(:,:,jpmldevd)   ! - due to isopycnal mixing scheme (implicit part)
-         smltrd(:,:,jpmldzdf) = smltrd(:,:,jpmldzdf) - smltrd(:,:,jpmldevd)   ! - due to isopycnal mixing scheme (implicit part)
-      ENDIF
-
-      ! Boundary conditions
-      CALL lbc_lnk( tmltrd, 'T', 1. )
-      CALL lbc_lnk( smltrd, 'T', 1. )
-
-      IF( idebug /= 0 ) THEN
-         WRITE(numout,*) ' debuging trd_mld: I. done'  
-         CALL FLUSH(numout)
-      ENDIF
-
-      !  =================================
-      !   II. Cumulated trends
-      !  =================================
-
-      ! II.1 set before values of vertically average T and S 
-      ! ---------------------------------------------------
-
+         tmltrd(:,:,jpmld_ldf) = tmltrd(:,:,jpmld_ldf) - tmltrd(:,:,jpmld_zdf)
+         smltrd(:,:,jpmld_ldf) = smltrd(:,:,jpmld_ldf) - smltrd(:,:,jpmld_zdf)
+      END IF
+
+      ! ... Lateral boundary conditions
+      DO jl = 1, jpltrd
+         CALL lbc_lnk( tmltrd(:,:,jl), 'T', 1. )
+         CALL lbc_lnk( smltrd(:,:,jl), 'T', 1. )
+      END DO
+
+      ! ======================================================================
+      ! II. Cumulate the trends over the analysis window
+      ! ======================================================================
+
+      ztmltrd2(:,:,:) = 0.e0   ;    zsmltrd2(:,:,:) = 0.e0  ! <<< reset arrays to zero
+      ztmltot2(:,:)   = 0.e0   ;    zsmltot2(:,:)   = 0.e0
+      ztmlres2(:,:)   = 0.e0   ;    zsmlres2(:,:)   = 0.e0
+      ztmlatf2(:,:)   = 0.e0   ;    zsmlatf2(:,:)   = 0.e0
+
+      ! II.1 Set before values of vertically average T and S 
+      ! ----------------------------------------------------
       IF( kt > nit000 ) THEN
-         tmlb(:,:) = tml(:,:)
-         smlb(:,:) = sml(:,:)
-      ENDIF
-
-      ! II.2 vertically integrated T and S
-      ! ---------------------------------
-
-      tml(:,:) = 0.
-      sml(:,:) = 0.
-
+         !   ... temperature ...                    ... salinity ...
+         tmlb   (:,:) = tml   (:,:)           ; smlb   (:,:) = sml   (:,:)
+         tmlatfn(:,:) = tmltrd(:,:,jpmld_atf) ; smlatfn(:,:) = smltrd(:,:,jpmld_atf)
+      END IF
+
+      ! II.2 Vertically averaged T and S
+      ! --------------------------------
+      tml(:,:) = 0.e0   ;   sml(:,:) = 0.e0
       DO jk = 1, jpktrd - 1
          tml(:,:) = tml(:,:) + wkx(:,:,jk) * tn(:,:,jk)
